<template>
  <div class="flex justify-content-end pt-4 pr-4">
    <Button @click="showNewNote" label="New Note" />
  </div>
  <div class="flex flex-column md:flex-row p-4">
    <div v-for="note in $store.state.notes" :key="note.id">
      <div class="surface-0 p-4 m-3 shadow-2 border-round">
        <div class="text-3xl font-medium text-900 mb-3">{{ note.title }}</div>
        <div
          style="height: 150px"
          class="border-2 border-dashed border-300 p-2"
        >
          {{ note.note }}
        </div>
        <div class="flex justify-content-end pt-3">
          <Button
            @click="deleteNote(note.id)"
            label="Delete"
            class="p-button-danger"
            icon="pi pi-trash"
          />
        </div>
      </div>
    </div>
  </div>

  <Dialog
    class="ml-2 mr-2 md:ml-8 md:mr-8"
    @hide="dialogHide"
    header="New Note"
    v-model:visible="display"
    :modal="true"
    :closeOnEscape="true"
  >
    <form @submit.prevent="createNewNote">
      <div class="surface-section pt-2 md:pt-4">
        <div class="grid formgrid p-fluid">
          <div v-if="error.isShown" class="field mb-2 md:mb-4 col-12">
            <Message @close="resetError" severity="error" class="w-auto">{{
              error.message
            }}</Message>
          </div>
          <div class="field mb-2 md:mb-4 col-12">
            <label for="title" class="font-medium">Title</label>
            <InputText v-model="newNote.title" id="title" />
          </div>
          <div class="field mb-2 md:mb-4 col-12">
            <label for="note" class="font-medium">Note</label>
            <Textarea
              v-model="newNote.note"
              id="note"
              :autoResize="true"
              rows="5"
              cols="30"
            />
          </div>
          <div class="col-12 flex justify-content-end">
            <Button label="Create Note" type="submit" class="w-auto" />
          </div>
        </div>
      </div>
    </form>
  </Dialog>

  <ConfirmDialog />
</template>

<script>
import noteService from "@/services/note-service";

export default {
  name: "Notes",
  data() {
    return {
      display: false,
      newNote: {
        title: "",
        note: "",
      },
      error: {
        message: "Test",
        isShown: false,
      },
    };
  },
  methods: {
    showNewNote() {
      this.display = true;
    },
    async createNewNote() {
      if (this.newNote.title === "" || this.newNote.note === "") {
        this.error = {
          message: "Enter title and note",
          isShown: true,
        };
        return;
      }

      try {
        const newDoc = await noteService.create(this.newNote);
        if (newDoc) {
          this.display = false;
          this.$store.commit("init");
        }
      } catch (e) {
        console.error(e);
      }
    },
    async deleteNote(id) {
      this.$confirm.require({
        message: "Are you sure you want to proceed?",
        header: "Confirmation",
        icon: "pi pi-exclamation-triangle",
        accept: async () => {
          await noteService.delete(id);
          this.$store.commit("init");
        },
        reject: () => {},
      });
    },
    resetForm() {
      this.newNote = {
        title: "",
        note: "",
      };
    },
    resetError() {
      this.error = {
        message: "",
        isShown: false,
      };
      console.log("error reset");
    },
    dialogHide() {
      this.resetError();
    },
  },
  async mounted() {
    this.$store.commit("init");
  },
};
</script>

<style scoped>
</style>